scala.reflect.api.JavaUniverse

# JavaMirror

###
Related Doc: package JavaUniverse

#### trait JavaMirror extends api.Mirror[JavaUniverse.this.type] with RuntimeMirror

A refinement of scala.reflect.api.Mirror for runtime reflection using JVM classloaders.

With this upgrade, mirrors become capable of converting Scala reflection artifacts (symbols and types) into Java reflection artifacts (classes) and vice versa. Consequently, refined mirrors become capable of performing reflective invocations (getting/setting field values, calling methods, etc).

For more information about `Mirrors`s, see scala.reflect.api.Mirrors or the Reflection Guide: Mirrors

Source
  JavaUniverse.scala

Linear Supertypes
JavaUniverse.RuntimeMirror, JavaUniverse.ReflectiveMirror, api.Mirror[JavaUniverse.this.type], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Grouped
2. Alphabetic
3. By inheritance

Inherited

1. JavaMirror
2. RuntimeMirror
3. ReflectiveMirror
4. Mirror
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def EmptyPackage: JavaUniverse.ModuleSymbol

   The module symbol of the default (unnamed) package

   The module symbol of the default (unnamed) package

   Definition Classes
     Mirror

2. #### abstract def EmptyPackageClass: JavaUniverse.ClassSymbol

   The module class symbol of the default (unnamed) package

   The module class symbol of the default (unnamed) package

   Definition Classes
     Mirror

3. #### abstract def RootClass: JavaUniverse.ClassSymbol

   The class symbol of the `_root_` package

   The class symbol of the `_root_` package

   Definition Classes
     Mirror

4. #### abstract def RootPackage: JavaUniverse.ModuleSymbol

   The module symbol of the `_root_` package

   The module symbol of the `_root_` package

   Definition Classes
     Mirror

5. #### abstract val classLoader: ClassLoader

6. #### abstract def classSymbol(rtcls: RuntimeClass): JavaUniverse.ClassSymbol

   A class symbol for the specified runtime class.

   A class symbol for the specified runtime class.

   returns

     The class symbol for the runtime class in the current class loader.

   Definition Classes
     RuntimeMirror
   Exceptions thrown

     `java.lang.ClassNotFoundException` if no class with that name exists

     `scala.reflect.ScalaReflectionException` if no corresponding symbol exists to do: throws anything else?

7. #### abstract def moduleSymbol(rtcls: RuntimeClass): JavaUniverse.ModuleSymbol

   A module symbol for the specified runtime class.

   A module symbol for the specified runtime class.

   returns

     The module symbol for the runtime class in the current class loader.

   Definition Classes
     RuntimeMirror
   Exceptions thrown

     `java.lang.ClassNotFoundException` if no class with that name exists

     `scala.reflect.ScalaReflectionException` if no corresponding symbol exists to do: throws anything else?

8. #### abstract def reflect[T](obj: T)(implicit arg0: ClassTag[T]): JavaUniverse.InstanceMirror

   A reflective mirror for the given object.

   A reflective mirror for the given object.

   Such a mirror can be used to further reflect against the members of the object to get/set fields, invoke methods and inspect inner classes and objects.

   Definition Classes
     ReflectiveMirror

9. #### abstract def reflectClass(cls: JavaUniverse.ClassSymbol): JavaUniverse.ClassMirror

   Reflects against a static class symbol and returns a mirror that can be used to create instances of the class, inspect its companion object or perform further reflections.

   Reflects against a static class symbol and returns a mirror that can be used to create instances of the class, inspect its companion object or perform further reflections.

   To get a class symbol by the name of the class you would like to reflect, use `<this mirror>.classSymbol(<runtime class loaded by its name>)`.

   The input symbol can be either private or non-private (Scala reflection transparently deals with visibility). It must be static, i.e. either top-level or nested within one or several static objects.

   Definition Classes
     ReflectiveMirror

10. #### abstract def reflectModule(mod: JavaUniverse.ModuleSymbol): JavaUniverse.ModuleMirror

    Reflects against a static module symbol and returns a mirror that can be used to get the instance of the object or inspect its companion class.

    Reflects against a static module symbol and returns a mirror that can be used to get the instance of the object or inspect its companion class.

    To get a module symbol by the name of its companion class you would like to reflect, use `<this mirror>.classSymbol(<runtime class loaded by its name>).companion.get`.

    The input symbol can be either private or non-private (Scala reflection transparently deals with visibility). It must be static, i.e. either top-level or nested within one or several static objects.

    Definition Classes
      ReflectiveMirror

11. #### abstract def runtimeClass(cls: JavaUniverse.ClassSymbol): RuntimeClass

    Maps a Scala class symbol to the corresponding Java class object

    Maps a Scala class symbol to the corresponding Java class object

    Definition Classes
      RuntimeMirror
    Exceptions thrown

      `ClassNotFoundException` if there is no Java class corresponding to the given Scala class symbol. Note: If the Scala symbol is ArrayClass, a ClassNotFound exception is thrown because there is no unique Java class corresponding to a Scala generic array

12. #### abstract def runtimeClass(tpe: JavaUniverse.Type): RuntimeClass

    Maps a Scala type to the corresponding Java class object

    Maps a Scala type to the corresponding Java class object

    Definition Classes
      RuntimeMirror

13. #### abstract def staticClass(fullName: String): JavaUniverse.ClassSymbol

    The symbol corresponding to the globally accessible class with the given fully qualified name `fullName`.

    The symbol corresponding to the globally accessible class with the given fully qualified name `fullName`.

    If the name points to a type alias, it's recursively dealiased and its target is returned. If you need a symbol that corresponds to the type alias itself, load it directly from the package class:

    scala> cm.staticClass("scala.List") res0: scala.reflect.runtime.universe.ClassSymbol = class List

    scala> res0.fullName res1: String = scala.collection.immutable.List

    scala> cm.staticPackage("scala") res2: scala.reflect.runtime.universe.ModuleSymbol = package scala

    scala> res2.moduleClass.info member TypeName("List") res3: scala.reflect.runtime.universe.Symbol = type List

    scala> res3.fullName res4: String = scala.List

    To be consistent with Scala name resolution rules, in case of ambiguity between a package and an object, the object is never been considered.

    For example for the following code:

    package foo { class B }

    object foo { class A class B }

    staticClass("foo.B") will resolve to the symbol corresponding to the class B declared in the package foo, and staticClass("foo.A") will throw a ScalaReflectionException.

    In the example above, to load a symbol that corresponds to the class B declared in the object foo, use staticModule("foo") to load the module symbol and then navigate info.members of its moduleClass.

    Definition Classes
      Mirror

14. #### abstract def staticModule(fullName: String): JavaUniverse.ModuleSymbol

    The symbol corresponding to the globally accessible object with the given fully qualified name `fullName`.

    The symbol corresponding to the globally accessible object with the given fully qualified name `fullName`.

    To be consistent with Scala name resolution rules, in case of ambiguity between a package and an object, the object is never been considered.

    For example for the following code:

    package foo { object B }

    object foo { object A object B }

    staticModule("foo.B") will resolve to the symbol corresponding to the object B declared in the package foo, and staticModule("foo.A") will throw a ScalaReflectionException

    In the example above, to load a symbol that corresponds to the object B declared in the object foo, use staticModule("foo") to load the module symbol and then navigate info.members of its moduleClass.

    Definition Classes
      Mirror

15. #### abstract def staticPackage(fullName: String): JavaUniverse.ModuleSymbol

    The symbol corresponding to a package with the given fully qualified name `fullName`.

    The symbol corresponding to a package with the given fully qualified name `fullName`.

    Definition Classes
      Mirror

16. #### abstract def symbolOf[T](implicit arg0: JavaUniverse.WeakTypeTag[T]): JavaUniverse.TypeSymbol

    Type symbol of `x` as derived from a type tag.

    Type symbol of `x` as derived from a type tag.

    Definition Classes
      Mirror

17. #### abstract val universe: JavaUniverse.this.type

    The universe this mirror belongs to.

    The universe this mirror belongs to.

    Definition Classes
      Mirror

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JavaMirror to any2stringadd[JavaMirror] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (JavaMirror, B)

   Implicit information
     This member is added by an implicit conversion from JavaMirror to ArrowAssoc[JavaMirror] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (JavaMirror) ⇒ Boolean, msg: ⇒ Any): JavaMirror

   Implicit information
     This member is added by an implicit conversion from JavaMirror to Ensuring[JavaMirror] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (JavaMirror) ⇒ Boolean): JavaMirror

   Implicit information
     This member is added by an implicit conversion from JavaMirror to Ensuring[JavaMirror] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): JavaMirror

    Implicit information
      This member is added by an implicit conversion from JavaMirror to Ensuring[JavaMirror] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): JavaMirror

    Implicit information
      This member is added by an implicit conversion from JavaMirror to Ensuring[JavaMirror] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from JavaMirror to StringFormat[JavaMirror] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      JavaMirror → AnyRef → Any

24. #### def typeOf[T](implicit arg0: JavaUniverse.TypeTag[T]): JavaUniverse.Type

    Shortcut for `implicitly[TypeTag[T]].tpe`

    Shortcut for `implicitly[TypeTag[T]].tpe`

    Definition Classes
      Mirror

25. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### def weakTypeOf[T](implicit arg0: JavaUniverse.WeakTypeTag[T]): JavaUniverse.Type

    Shortcut for `implicitly[WeakTypeTag[T]].tpe`

    Shortcut for `implicitly[WeakTypeTag[T]].tpe`

    Definition Classes
      Mirror

29. #### def →[B](y: B): (JavaMirror, B)

    Implicit information
      This member is added by an implicit conversion from JavaMirror to ArrowAssoc[JavaMirror] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from JavaUniverse.RuntimeMirror

### Inherited from JavaUniverse.ReflectiveMirror

### Inherited from api.Mirror[JavaUniverse.this.type]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JavaMirror to any2stringadd[JavaMirror]

### Inherited by implicit conversion StringFormat from JavaMirror to StringFormat[JavaMirror]

### Inherited by implicit conversion Ensuring from JavaMirror to Ensuring[JavaMirror]

### Inherited by implicit conversion ArrowAssoc from JavaMirror to ArrowAssoc[JavaMirror]

### Mirror

### TypeTags

### Ungrouped